//
// Das WildeTiere-Beispiel aus der Vorlesung.
//

// Die Klasse WildeTiereStarter startet das Programm.
public class WildeTiere {
	public static void main (String[] args) { 
		// Ein Zoo-Objekt erstellen und die Methode losGehts() aufrufen
		Zoo zoo = new Zoo();
		zoo.losGehts();
	}
} 


// Der Zoo managt die wilden Tiere und reagiert auf die Benutzereingabe.
class Zoo {	
	// Tier-Objekte erzeugen und Benutzereingabe abfragen
	public void losGehts () { 
		// Ein Array fr alle vier Tiere
		Tier[] alleTiere = new Tier[4];

		// Ein Objekt jedes Tieres erzeugen und in das Array stecken
		// Die Instanzvariablen fuer jedes Tier mit sinnvollen Werten initialisieren
		alleTiere[0] = new Affe ();
		alleTiere[0].setTierart ("Affe");
		alleTiere[0].setHerkunftsland ("Brasilien");
		alleTiere[0].setAlter (5);
		alleTiere[0].setGeschlecht ("maennlich");
		alleTiere[0].setName ("Tarzan");
		
		alleTiere[1] = new Loewe ();
		alleTiere[1].setTierart ("Loewe");
		alleTiere[1].setHerkunftsland ("Kenia");
		alleTiere[1].setAlter(13);
		alleTiere[1].setGeschlecht("weiblich");
		alleTiere[1].setName ("Lisa");

		alleTiere[2] = new Baer ();
		alleTiere[2].setTierart ("Baer");
		alleTiere[2].setHerkunftsland ("Polen");
		alleTiere[2].setAlter (20);
		alleTiere[2].setGeschlecht("weiblich");
		alleTiere[2].setName ("Susie");
		
		alleTiere[3] = new Hase ();		
		alleTiere[3].setTierart ("Hase");
		alleTiere[3].setHerkunftsland ("Belgien");
		alleTiere[3].setAlter (3);
		alleTiere[3].setGeschlecht ("maennlich");
		alleTiere[3].setName ("Hase");
		
		// BenutzerEingabe-Objekt erstellen 
		Benutzereingabe eingabe = new Benutzereingabe ();

		// hier speichern wir die Auswahl des Benutzers
		String gewaehltesTier;
		
		System.out.println ("Sie sind im Zoo und laufen herum. Beruehren Sie ein Tier mit Ihrer Tastatur, damit Ihnen dieses Tier etwas ueber sich erzaehlt:");

		// Hey, wer hat gesagt, da do-while-Schleife keinen Sinn machen?
		do {
			// Eingabe von der Tastatur speichern und in Kleinbuchstaben umwandeln
			gewaehltesTier = eingabe.getBenutzereingabe ("\nWas beruehren Sie: Affe, Loewe, Baer, Hase oder Ende?");
			gewaehltesTier = gewaehltesTier.toLowerCase ();
			
			if (gewaehltesTier.equals ("affe")) {
				alleTiere[0].erzaehlWas ();
			} else if (gewaehltesTier.equals ("loewe")) {
				alleTiere[1].erzaehlWas ();
			} else if (gewaehltesTier.equals ("baer")) {
				alleTiere[2].erzaehlWas ();
			} else if (gewaehltesTier.equals ("hase")) {
				alleTiere[3].erzaehlWas ();
			} else {
				System.out.println (gewaehltesTier.toUpperCase () + " gibt's noch nicht!");
			}
			
		} while (!gewaehltesTier.equals ("ende"));
		
		// am Ende alle Tiere nacheinander erzhlen lassen
		System.out.println ("\nBevor Sie gehen, melden sich alle Tiere nochmal zu Wort:");
		for (Tier einTier : alleTiere) {
			einTier.erzaehlWas ();
		}
	}
}


// Die Superklasse vererbt die gemeinsamen Instanzvariablen und Methoden fuer alle Tiere.
class Tier {
	// Instanzvariablen
	private String tierart;
	private String herkunftsland;
	private int alter;
	private String geschlecht;
	private String name;

	// Methoden
	
	// Infos ueber die Tiere ausgeben
	public void erzaehlWas () {
		System.out.println ("\nMein Name ist " + name + ".");		
		System.out.println ("Ich bin ein " + tierart + ".");
		System.out.println ("Ich komme aus " + herkunftsland + ".");
		System.out.println ("Mittlerweile bin ich " + alter + " Jahre jung.");
		System.out.println ("Und ich bin " + geschlecht + ".");
	}

	// in dieser Uebung machen Tiere noch keine Geraeusche
	public void geraeuschMachen () {
	}
	
	
	// Getter und Setter
	public void setTierart (String art) {
		tierart = art;
	}

	public String getTierart () {
		return tierart;
	}	
	
	public void setHerkunftsland (String herkunft) {
		herkunftsland = herkunft;
	}
	
	public String getHerkunftsland () {
		return herkunftsland;
	}
	
	public void setAlter (int jahre) {
		alter = jahre;
	}
	
	public int getAlter () {
		return alter;
	}
	
	public void setGeschlecht (String sex) {
		geschlecht = sex;
	}
	
	public String getGeschlecht () {
		return geschlecht;
	}
	
	public void setName (String manNenntMich) {
		name = manNenntMich;
	}
	
	public String getName () {
		return name;
	}
} 


// diese Klassen erben alle von der Superklasse Tier
class Affe extends Tier {
}


class Loewe extends Tier {
	// die Methode erzaehlWas fuer den Loewen ueberschreiben
	public void erzaehlWas () {
		// zuerst die Methode der Superklasse aufrufen, dann den Hinweis ausgeben, da Loewen vom Aussterben bedroht sind
		super.erzaehlWas ();
		System.out.println ("Au wei! Ich bin vom Aussterben bedroht!");
	}	
}


class Baer extends Tier {
}


class Hase extends Tier {
}